﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using C1.C1Preview;
using System.Drawing.Imaging;
using System.Collections;
using C1.Win.C1List;

namespace C1Report_PreviewSpecificPages
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            c1Report1.Load("../../CommonTasks.xml", "01: Alternating Background (Greenbar report)");
            c1Report1.Render();

            int pages = c1Report1.GetPageCount();

            c1Combo1.DataMode = C1.Win.C1List.DataModeEnum.AddItem;
            c1Combo2.DataMode = C1.Win.C1List.DataModeEnum.AddItem;
            c1List1.DataMode = C1.Win.C1List.DataModeEnum.AddItem;
            c1List1.SelectionMode = C1.Win.C1List.SelectionModeEnum.CheckBox;

            for (int i = 0; i < pages; i++)
            {
                c1Combo1.AddItem((i + 1).ToString());
                c1Combo2.AddItem((i + 1).ToString());
                c1List1.AddItem((i + 1).ToString());
            }
        }

        private void button1_Click(object sender, EventArgs e)
        {
            if (c1Combo2.SelectedIndex != -1 && c1Combo1.SelectedIndex != -1)
            {
                if (Convert.ToInt32(c1Combo2.Text) < Convert.ToInt32(c1Combo1.Text))
                {
                    MessageBox.Show("End Page cannot be lower than Start Page");
                }
                else
                {
                    int fromPage = Convert.ToInt32(c1Combo1.Text);
                    int toPage = Convert.ToInt32(c1Combo2.Text);
                    int pageCount = toPage - fromPage;

                    ArrayList Pages = new ArrayList();

                    for (int i = fromPage - 1; i < toPage; i++)
                    {
                        Pages.Add(c1Report1.GetPageImage(i));
                    }
                    RenderPrintPreviewDialog(Pages);
                }
            }
        }

        private void button2_Click(object sender, EventArgs e)
        {
            if (c1List1.SelectedIndex != -1)
            {
                SelectedRowCollection items = c1List1.SelectedIndices;

                if (items.Count > 0)
                {
                    ArrayList Pages = new ArrayList();

                    foreach (var item in items)
                    {
                        Pages.Add(c1Report1.GetPageImage(Convert.ToInt32(item)));
                    }
                    RenderPrintPreviewDialog(Pages);
                }
                else
                {
                    MessageBox.Show("Please select atleast one item");
                }
            }
        }

        public void RenderPrintPreviewDialog(ArrayList pages)
        {
            C1PrintDocument doc = new C1PrintDocument();

            doc.PageLayout.PageSettings.LeftMargin = "0.0in";
            doc.PageLayout.PageSettings.TopMargin = "0.0in";

            //Add Page Images to C1PrintDocument
            foreach (Metafile pageImage in pages)
            {
                RenderImage renderImage = new RenderImage(pageImage);
                doc.Body.Children.Add(renderImage);
                doc.Reflow();
            }

            c1PrintPreviewDialog1 = new C1.Win.C1Preview.C1PrintPreviewDialog();

            c1PrintPreviewDialog1.Width = 700;
            c1PrintPreviewDialog1.Height = 700;

            c1PrintPreviewDialog1.Show();
            c1PrintPreviewDialog1.Document = doc;
        }
    }
}
